<?php

class fewestAiredShowsSchedulingRule extends timeslotSchedulingRule {
  public function executeRule() {
    $shows = array();
    $query = db_select('node', 'n');
    $query->fields('n', array('nid'));
    $query->condition('type', 'om_show', '=');
    $result = $query->execute();
    while($nids = $result->fetchAssoc()) {
      $node = node_load($nids['nid']);
      if ($node->field_om_show_duration['und'][0]['value'] > 800) {
        $shows[] = $node;
      }
    }
    return array_values($shows);
  }
}

function make_dummy_show_list($count, $range) {
  $shows = array();
  for ($i = 0; $i < $count; $i++) {
    $show = new stdClass();
    $show->title = 'Test Show: ' . $i;
    $show->field_om_show_broadcast_file['und'][0]['uri'] = 'public://my.mpeg';
    $show->field_om_show_duration['und'][0]['value'] = rand(900, $range);
    $shows[] = $show;
  }
  return $shows;
}